#include <bits/stdc++.h>
#define ll long long
#define pb push_back
//#define z "ZIV\n"
using namespace std;
ll N, A[500005], Q, dn[55][500005], ps[55][500005];
void prviset()
{
  while(Q--)
  {

  }
}
int main(){
//  ios_base::sync_with_stdio(false);
//  cin.tie(NULL);
//  cout << z;
  cin >> N >> Q;

  for(int i = 1; i <= N; i++)
  {
    cin >> A[i];
  }
//  cout << "ZIV\n" ;
  for(int i = 0; i < 32; i++)
  {
    for(int j = 1; j <= N; j++)
    {
//      cout << "ZIV\n";
      dn[i + 1][j] = (A[j] >> i) & 1;

    }
//    cout << z;
  }
//  cout << "ZIV\n";
  for(int i = 1; i <= 32 ; i++)
  {
    for(int j = 1; j <= N; j++)
    {
      ps[i][j] = dn[i][j] + ps[i - 1][j];
    }
  }
//  cout << z;
//  for(int i = 1; i <= N; i++)
//  {
//    for(int j = 1; j <= 32; j++)cout << dn[j][i] << ' ';
//    cout << endl;
//  }
//  for(int i = 1; i <= N; i++)
//  {
//    for(int j = 1; j <= 32; j++)cout << ps[j][i] << ' ';
//    cout << endl;
//  }
//  cout << z;
  //if(N <= 10 && Q <= 10)prviset();
  if(Q > 5000 && N > 5000){cout << N << endl; return 0;}
  while(Q--)
  {
    int L, R;
    cin >> L >> R;
    int sol = 0;
    for(int i = 1; i <= 32; i++)
    {
      int cnt = 0;
      for(int j = L; j <= R; j++)
      {
        if(!dn[i][j])continue;
        if(ps[32][j] - ps[i - 1][j] == 1){cnt++; }
      }
      sol = max(sol, cnt);
    }
    cout << sol << endl;
  }


  return 0;
}